//		Copyright © 2000  Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Screen saver configuration view.

#ifndef SAMHAINCONFIGVIEW_H
#define SAMHAINCONFIGVIEW_H

#include <Rect.h>
#include <TabView.h>

class SamhainPreferences;

class SamhainConfigView : public BTabView
{
	typedef BTabView inherited;
public:
	SamhainConfigView(BRect frame, SamhainPreferences &preferences);
	virtual ~SamhainConfigView(void);

	// Hook functions.
	virtual void AttachedToWindow(void);
	virtual void MessageReceived(BMessage *pMsg);
		
private:
	SamhainConfigView(const SamhainConfigView &orig);
	SamhainConfigView &operator =(const SamhainConfigView &orig);
	
	// Message type codes.
	enum {
		kReset = ' rst'		// reset preferences to default values
	};

	// Data members.
	SamhainPreferences &mPreferences;
};
	
#endif // SAMHAINCONFIGVIEW_H
