//		Copyright © 2000  Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Configuration view for knot preferences.

#ifndef SAMHAINKNOTCONFIGVIEW_H
#define SAMHAINKNOTCONFIGVIEW_H

#include <Rect.h>
class BSlider;
#include <SupportDefs.h>

class IntervalSlider;
#include "SamhainConfigViewBase.h"
class SamhainKnotPreferences;

class SamhainKnotConfigView : public SamhainConfigViewBase
{
	typedef SamhainConfigViewBase inherited;
public:
	SamhainKnotConfigView(BRect frame, const char *pName,
								 SamhainKnotPreferences &preferences);
	virtual ~SamhainKnotConfigView(void);

	// Hook functions.
	virtual void AllAttached(void);
	virtual void AttachedToWindow(void);

private:
	SamhainKnotConfigView(const SamhainKnotConfigView &);
	SamhainKnotConfigView &operator =(const SamhainKnotConfigView &);
	
	// Data members.
	SamhainKnotPreferences &mPreferences;	// user preferences
	
	Command *mpSetKnotDistribution;			// function objects
	Command *mpSetSectionDistribution;
	Command *mpSetCornerDistribution;
	Command *mpSetFatKnotProbability;
	Command *mpSetHollowKnotProbability;
	
	IntervalSlider *mpKnotSlider;				// controls
	IntervalSlider *mpSectionSlider;
	IntervalSlider *mpCornerSlider;
	BSlider *mpFatKnotSlider;
	BSlider *mpHollowKnotSlider;
};

#endif // SAMHAINKNOTCONFIGVIEW_H
