//		Copyright © 2000  Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Configuration view for saver/preview preferences.

#ifndef SAMHAINSAVERCONFIGVIEW_H
#define SAMHAINSAVERCONFIGVIEW_H

#include <Rect.h>
#include <SupportDefs.h>

class IntervalSlider;
#include "SamhainConfigViewBase.h"
class SamhainSaverPreferences;

class SamhainSaverConfigView : public SamhainConfigViewBase
{
	typedef SamhainConfigViewBase inherited;
public:
	SamhainSaverConfigView(BRect frame, const char *pName,
								  int16 minNumKnots, int16 maxNumKnots,
								  uint32 hashMarksNumKnots,
								  bigtime_t minDelay, bigtime_t maxDelay,
								  uint32 hashMarksDelay,
								  SamhainSaverPreferences &preferences);
	virtual ~SamhainSaverConfigView(void);

	// Hook functions.
	virtual void AllAttached(void);
	virtual void AttachedToWindow(void);

private:
	SamhainSaverConfigView(const SamhainSaverConfigView &);
	SamhainSaverConfigView &operator =(const SamhainSaverConfigView &);
	
	// Data members.
	const int16 mMinNumKnots;								// data for UI setup
	const int16 mMaxNumKnots;
	const uint32 mHashMarksNumKnots;
	const bigtime_t mMinDelay;
	const bigtime_t mMaxDelay;
	const uint32 mHashMarksDelay;

	SamhainSaverPreferences &mPreferences;	// user preferences
	
	Command *mpSetNumKnots;						// function objects
	Command *mpSetDelay;
	Command *mpSetSize;
	
	IntervalSlider *mpKnotsSlider;			// controls
	IntervalSlider *mpDelaySlider;
	IntervalSlider *mpSizeSlider;
};

#endif // SAMHAINSAVERCONFIGVIEW_H
