//		Copyright © 1999–2000  Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Screen saver class.

#ifndef SAMHAINSCREENSAVER_H
#define SAMHAINSCREENSAVER_H

#include <Bitmap.h>
#include <image.h>
#include <Message.h>
#include <Point.h>
#include <Rect.h>
#include <ScreenSaver.h>
#include <SupportDefs.h>
#include <View.h>

#include "SamhainPreferences.h"

class SamhainScreenSaver : public BScreenSaver
{
	typedef BScreenSaver inherited;
public:
	SamhainScreenSaver(BMessage *pMsg, image_id id);
	virtual ~SamhainScreenSaver(void);
	
	// Hook functions.
	virtual void Draw(BView *pView, int32 frame);
	virtual status_t SaveState(BMessage *pMsg) const;
	virtual void StartConfig(BView *pConfigView);
	virtual status_t StartSaver(BView *pView, bool preview);

private:
	SamhainScreenSaver(const SamhainScreenSaver &orig);
	SamhainScreenSaver &operator =(const SamhainScreenSaver &orig);

	// Knot types.
	enum KnotType {
		kClosed,
		kHorizontal,
		kVertical
	};
		
	// Data members.
	SamhainPreferences mPreferences;	// user preferences
	
	bigtime_t mTimer;						// time to next event
	bigtime_t mLogoTimer;				// time to next showing of Be logo
	BBitmap *mpLogo;						// Be logo data
	BRect mLogoBounds;
	BPoint mLogoPosition;
	int16 mKnotsToDraw;					// number of knots to be drawn
	bool mPreviewing;						// true iff running in preview mode
	bool mShowingLogo;					// true iff logo is being shown
};
	
#endif
